<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */
--%>

<%@ include file="/html/js/editor/init.jsp" %>

<%@ taglib uri="http://liferay.com/tld/util" prefix="liferay-util" %>

<%
PortletResponse portletResponse = (PortletResponse)request.getAttribute(JavaConstants.JAVAX_PORTLET_RESPONSE);

String namespace = StringPool.BLANK;

boolean auiFormUseNamespace = GetterUtil.getBoolean((String)request.getAttribute("aui:form:useNamespace"), true);

if ((portletResponse != null) && auiFormUseNamespace) {
	namespace = portletResponse.getNamespace();
}

final String name = namespace + GetterUtil.getString((String)request.getAttribute("liferay-ui:input-editor:name"));

CustomCKEditorOutputData customCKEditorOutputData = new CustomCKEditorOutputData(request, name);

customCKEditorOutputData.wrap();

CustomCKEditorScriptData customCKEditorScriptData = new CustomCKEditorScriptData(request, name);

customCKEditorScriptData.wrap();
%>

<liferay-util:buffer var="html">
	<liferay-util:include page="/html/js/editor/ckeditor.jsp" />
</liferay-util:buffer>

<%
customCKEditorOutputData.unwrap();

customCKEditorScriptData.unwrap();
%>

<%= _replaceVariations(html) %>

<%!
private static class CustomCKEditorScriptData extends ScriptData {

	public CustomCKEditorScriptData(HttpServletRequest request, String name) {
		_request = request;
		_name = name;
	}

	@Override
	public void append(String portletId, StringBundler contentSB, String use) {
		_replaceVariations(contentSB, _name);

		_scriptData.append(portletId, contentSB, use);
	}

	public void unwrap() {
		_request.setAttribute(WebKeys.AUI_SCRIPT_DATA, _scriptData);
	}

	public void wrap() {
		_scriptData = (ScriptData)_request.getAttribute(WebKeys.AUI_SCRIPT_DATA);

		if (_scriptData == null) {
			_scriptData = new ScriptData();
		}

		_request.setAttribute(WebKeys.AUI_SCRIPT_DATA, this);
	}

	private String _name;
	private HttpServletRequest _request;
	private ScriptData _scriptData;

}

private static class CustomCKEditorOutputData extends OutputData {

	public CustomCKEditorOutputData(HttpServletRequest request, String name) {
		_request = request;
		_name = name;
	}

	@Override
	public void addData(String outputKey, String webKey, StringBundler sb) {
		_replaceVariations(sb, _name);

		_outputData.addData(outputKey, webKey, sb);
	}

	public void unwrap() {
		_request.setAttribute(WebKeys.OUTPUT_DATA, _outputData);
	}

	public void wrap() {
		_outputData = (OutputData)_request.getAttribute(WebKeys.OUTPUT_DATA);

		if (_outputData == null) {
			_outputData = new OutputData();
		}

		_request.setAttribute(WebKeys.OUTPUT_DATA, this);
	}

	private String _name;
	private OutputData _outputData;
	private HttpServletRequest _request;

}

private static String _replaceVariations(String content) {
	content = StringUtil.replace(content, "/ckeditor/", "/ckeditor_latest/");
	content = StringUtil.replace(content, "CKEDITOR.env.isCompatible = true;", "");

	return content;
}

private static void _replaceVariations(StringBundler sb, String name) {
	String content = sb.toString();

	content = _replaceVariations(content);
	content = StringUtil.replace(content, "&resizable=", "&name=" + name + "&resizable=");

	sb.setIndex(0);

	sb.append(content);
}
%>